package org.japura.task;

import java.util.List;

import org.japura.controller.Group;
import org.japura.debug.DebugComponent;
import org.japura.debug.DebugResult;
import org.japura.task.ui.TaskExecutionUI;

/**
 * <P>
 * Copyright (C) 2011-2013 Carlos Eduardo Leite de Andrade
 * <P>
 * This library is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * <P>
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * <P>
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <A
 * HREF="www.gnu.org/licenses/">www.gnu.org/licenses/</A>
 * <P>
 * For more information, contact: <A HREF="www.japura.org">www.japura.org</A>
 * <P>
 * 
 * @author Carlos Eduardo Leite de Andrade
 */
public interface TaskManager extends TaskSubmitter{

  public void addListener(TaskManagerListener listener);

  public void removeListener(TaskManagerListener listener);

  public void fireTaskManagerListeners(TaskManagerEvent event, Task<?> task);

  public void fireTaskExecutionUIs(TaskManagerEvent event, Task<?> task);

  public List<TaskManagerListener> getListeners();

  public boolean hasTask(Group group);

  public boolean hasTask();

  public void cancel(String controllerGroupId);

  public void cancelAll();

  public int getQueueCount();

  public DebugComponent createDebugPanel();

  public void showDebugWindow();

  public List<DebugResult> addToDebugWindow(Task<?> task, TaskEvent event);

  public void addToDebugWindow(Task<?> task);

  public void removeFromDebugWindow(Task<?> task);

  public void notifyAfterTaskExecution(Task<?> task);

  public void setTaskSessionFactory(TaskSessionFactory taskSessionFactory);

  public TaskSessionFactory getTaskSessionFactory();

  public TaskExecutionUI getTaskExecutionUI();

  public void setTaskExecutionUI(TaskExecutionUI taskExecutionUI);
}
