package org.japura.task;

import java.util.HashMap;
import java.util.Map;

import org.japura.Application;

/**
 * <P>
 * Copyright (C) 2012 Carlos Eduardo Leite de Andrade
 * <P>
 * This library is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * <P>
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * <P>
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <A
 * HREF="www.gnu.org/licenses/">www.gnu.org/licenses/</A>
 * <P>
 * For more information, contact: <A HREF="www.japura.org">www.japura.org</A>
 * <P>
 * 
 * @author Carlos Eduardo Leite de Andrade
 */
public class TaskSession{

  private String id;
  private Map<Object, Object> values;

  public TaskSession() {
	this.values = new HashMap<Object, Object>();
	this.id = Application.buildId();
  }

  public final String getId() {
	return id;
  }

  public void put(Object key, Object value) {
	values.put(key, value);
  }

  public void put(Object value) {
	values.put(value.getClass(), value);
  }

  public <T> T get(Class<T> clss) {
	Object obj = values.get(clss);
	if (obj != null) {
	  return clss.cast(obj);
	}
	return null;
  }

  public Object get(Object key) {
	return values.get(key);
  }

  public void clear(Object key) {
	values.remove(key);
  }

  public boolean contains(Object key) {
	return values.containsKey(key);
  }

}
